Bug 445202 - rpm silently removes %config(noreplace) files when they become symlinks
rpm silently removes %config(noreplace) files when they become symlinks
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: rpm (Show other bugs)
18
All Linux
low Severity low
: ---
: ---
Assigned To: Florian Festi
Fedora Extras Quality Assurance
: Reopened, Triaged
Depends On:
Blocks: 915726
  Show dependency treegraph
 
Reported: 2008-05-05 09:59 EDT by Till Maas
Modified: 2013-03-27 03:26 EDT (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 915726 (view as bug list)
Environment:
Last Closed: 2013-03-27 03:26:30 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
old.spec (477 bytes, text/x-rpm-spec)
2013-02-26 06:28 EST, Miloslav Trmač
no flags Details
new.spec (530 bytes, text/x-rpm-spec)
2013-02-26 06:29 EST, Miloslav Trmač
no flags Details

  None (edit)
Description Till Maas 2008-05-05 09:59:46 EDT
Description of problem:
When a package contains files marked as %config(noreplace) and in a later
release of this package these files become symlinks, then these files are
silently removed and no .rpmsave file is kept.

Version-Release number of selected component (if applicable):
4.4.2.2-7.fc8

How reproducible:
always

Steps to Reproduce:
1. yum install mock-0.7.6-1.fc8
2. edit /etc/mock/fedora-5-i386-epel.cfg
3. yum update mock (to version 0.9.7-2.fc8)
  
Actual results:
after update /etc/mock/fedora-5-i386-epel.cfg is a symlink to epel-5-i386.cfg.
The original file fedora-5-i386-epel.cfg is lost.

Expected results:
1a) There should be a new symlink created: /etc/mock/fedora-5-i386-epel.cfg.rpmnew
1b) Or: fedora-5-i386-epel.cfg should be saved as epel-5-i386.cfg and a
epel-5-i386.cfg.rpmnew should be created
In conclusion: There should be copy of the fedora-5-i386-epel.cfg kept somewhere
and rpm should indicate, that manual intervention is needed.
Comment 1 Bug Zapper 2008-11-26 05:38:37 EST
This message is a reminder that Fedora 8 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 8.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '8'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 8's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 8 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Panu Matilainen 2009-01-08 07:36:39 EST
Still happens in F10
Comment 3 Bug Zapper 2009-11-18 07:29:16 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 4 Bug Zapper 2009-12-18 01:08:07 EST
Fedora 10 changed to end-of-life (EOL) status on 2009-12-17. Fedora 10 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 5 Till Maas 2010-01-03 17:04:10 EST
reproducible with rpm 4.7.2-1.fc12
Comment 6 Bug Zapper 2010-11-04 07:55:46 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 7 Bug Zapper 2010-12-05 02:11:04 EST
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 8 Miloslav Trmač 2013-02-26 06:28:57 EST
Created attachment 702800 [details]
old.spec

Still seeing this in rpm-4.10.3.1-1.fc18.x86_64.

To reproduce
> rpmbuild -ba old.spec 
> rpmbuild -ba new.spec 
> rpm -Uvh .../config-1-1.x86_64.rpm 
modify /etc/cfgxx/filename 
> rpm -Uvh .../config-2-1.x86_64.rpm 

Actual results: /etc/cfgxx/filename has been replaced by a symlink, throwing away the old contents.

Expected results: /etc/cfgxx/filename.rpmnew symlink created, /etc/cfgxx/filename unmodified.
Comment 9 Miloslav Trmač 2013-02-26 06:29:23 EST
Created attachment 702801 [details]
new.spec
Comment 10 Stef Walter 2013-03-19 14:28:58 EDT
This is no longer a dependency of the System Certificates work. The processing of the symlinks required custom processing, which Kai has written a script for.
Comment 11 Panu Matilainen 2013-03-27 03:26:30 EDT
Good. Then I'm going to close this NEXTRELEASE: this, along with numerous other %config related bugs, has been fixed in rpm >= 4.11 but backporting all the related and required changes even to 4.10 is just too involved and risky.

Note You need to log in before you can comment on or make changes to this bug.